package kano.captcha;

import java.io.File;

import javax.servlet.http.HttpServletRequest;

import kano.exception.LogicApplicationException;
import kano.util.BufferedQueue;

public class CaptchaMgr
{
	public static final CaptchaMgr s_instance = new CaptchaMgr();
	private BufferedQueue m_queue = null;
	
	public static CaptchaMgr getInstance()
	{
		return s_instance;
	}
	
	public CaptchaMgr()
	{
		
	}
	
	public synchronized void init(HttpServletRequest request, String dir)
	{
		deleteAll(dir);
		reloadCaptchas(dir);
	}
	
	private void deleteAll(String dir)
	{
		File f = new File(dir);
		if (!f.exists())
			f.mkdirs();
		
		System.out.println("Paso 1");
		File[] lf = f.listFiles();
		
		for (int i = 0; i < lf.length; i++)
		{
			lf[i].delete();
		}
	}
	
	public synchronized void reloadCaptchas(String strPath)
	{
		m_queue = new BufferedQueue(20);
		for (int i = 0; i < 20; i ++)
		{
			Captcha q = createCaptcha(strPath);
			m_queue.add(q.strKey, q);
		}
	}
	
	private Captcha createCaptcha(String strPath)
	{
		CaptchaFactory cf = new CaptchaFactory();
		
		return cf.createCaptcha(strPath);
	}
	
	public synchronized void checkCaptcha(String strKey, String strValue) throws Exception
	{
		if (m_queue == null)
			throw new LogicApplicationException("Invalid captcha");
		Captcha c = (Captcha)m_queue.get(strKey);
		System.out.println(strKey + "; #" + strValue + "#");
		if (c != null)
			System.out.println("code: #" + c.strText + "#; " + c.strText.equals(strValue));
		if (c == null || !c.strText.equals(strValue))
			throw new LogicApplicationException("Invalid captcha code");
		
	}
	
	public synchronized Captcha getNewCaptcha(HttpServletRequest request, String dir)
	{
		if (m_queue == null)
			init(request, dir);
		return (Captcha)m_queue.next();
	}
	
	

}
